/**
 * itm.js
 * 
 * $Id$
 * 
 * @package		In the Mood
 * @version		0.9.5
 * @author		Masayuki Iwai <miyabi@mybdesign.com>
 * @copyright	Copyright &copy; 2006-2013 Masayuki Iwai all rights reserved.
 **/


var g_Conf = {
	app_name             : "In the Mood", 
	app_code             : "inthemood", 
	version              : "ver.0.9.5", 
	width                : 320, 
	front_height         : 80, 
	back_height          : 228, 
	post_offset          : 0, 
	format               : "", 
	format_default       : "\u266a{name} - {artist}", 
	mood_text            : "", 
	mood_text_index      : 0, 
	current_song         : "", 
	current_artist       : "", 
	current_album        : "", 
	current_genre        : "", 
	short_title          : "", 
	short_artist         : "", 
	itunes_paused        : 0, 
	paused_index         : 0, 
	preset_index         : 0, 
	preset_count         : 10, 
	preset_text          : {0:"", 1:"", 2:"", 3:"", 4:"", 5:"", 6:"", 7:"", 8:"", 9:""}, 
	use_growl            : 0, 
	delay_auto_post      : 1, 
	delay_auto_post_duration: 10,  
	prefs_tab_count      : 3, 
	im_services          : {
		"adium": {use:0}, 
		"messages": {use:0}, 
		"ichat": {use:0}, 
		"skype": {use:0}
	}, 
	post_services        : {
		"blipfm": {
			name         : "blipfm", 
			label        : "Blip.fm", 
			use          : 0, 
			url          : "http://api.blip.fm/blip/post.json", 
			url_getparams: "http://www.mybdesign.com/itm/blipfm_get_params.php", 
			url_findsongs: "http://api.blip.fm/search/findSongs.json", 
			max_length   : 150, 
			params       : "apiKey=3df2ca94842aab165142", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}, 
		"friendfeed": {
			name         : "friendfeed", 
			label        : "FriendFeed", 
			use          : 0, 
			url          : "http://friendfeed.com/api/share", 
			max_length   : 140, 
			params       : "", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}, 
//		"jaiku": {
//			name         : "jaiku", 
//			label        : "Jaiku", 
//			use          : 0, 
//			url          : "http://api.jaiku.com/json", 
//			max_length   : 140, 
//			params       : "method=presence.send&icon=367", 
//			id           : "", 
//			pw           : "", 
//			auto         : 0, 
//			comment_only : 0
//		}, 
		"twitter": {
			name         : "twitter", 
			label        : "Twitter", 
			use          : 0, 
			url          : "", 
			max_length   : 140, 
			params       : "", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}, 
//		"wassr": {
//			name         : "wassr", 
//			label        : "Wassr", 
//			use          : 0, 
//			url          : "http://api.wassr.jp/statuses/update.json", 
//			max_length   : 255, 
//			params       : "", 
//			id           : "", 
//			pw           : "", 
//			auto         : 0, 
//			comment_only : 0
//		}
	}, 
	post_timeout         : 15, 
	post_error           : {
		304: "Not Modified", 
		400: "Bad Request", 
		401: "Not Authorized", 
		403: "Forbidden", 
		404: "Not Found", 
		500: "Internal Server Error", 
		502: "Bad Gateway", 
		503: "Service Unavailable", 
		997: "Song Not Found", 
		998: "Request Timed Out", 
		999: "Unknown Error"
	}, 
	hashtags             : [4], 
	hashtags_count       : 5, 
	characters_removed_from_hashtag: "[\\x20-\\x2f\\x3a-\\x40\\x5b-\\x5e\\x60\\x7b-\\x7e]", 
	last_checked         : 0, 
	check_for_updates    : 0, 
	check_for_upd_url    : "http://www.mybdesign.com/itm/latest_version.txt", 
	check_for_upd_timeout: 30, 
	check_for_upd_every  : 24 * 60 * 60, 
	cancel_auto_posting  : 1, 
	"": ""
};

var g_nPrefsTabIndex = 1;

var g_InfoButton;
var g_DoneButton;
var g_CancelButton;

var g_bSelectMoodTextShown = false;
var g_SelectMoodTextAnimator = null;
var g_SelectMoodTextAnimation = null;

var g_delayAutoPostTimer = null;

var g_CheckForUpdatesRequest = null;
var g_CheckForUpdatesTimer = null;

var g_PostRequest = {};
var g_PostTimer = {};
var g_nPostCount = 0;
var g_nPostButtonStatus = 0;
var g_PostErrors = [];
var g_nBlipCount = 0;


//////// Initialize widget
function Initialize()
{
	if(window.widget)
		window.widget.onshow = CheckForUpdates;

	document.getElementById("version").innerText = g_Conf.version;

	g_InfoButton = new AppleInfoButton(
		document.getElementById("info_button"), 
		document.getElementById("front"), 
		"white", "white", 
		ShowPrefs
	);

	g_DoneButton = new AppleGlassButton(
		document.getElementById("done_button"), 
		L("Done"), 
		HidePrefsWithApplyChanges
	);

	g_CancelButton = new AppleGlassButton(
		document.getElementById("cancel_button"), 
		L("Cancel"), 
		HidePrefsWithoutApplyChanges
	);
	
	// Initialize buttons
	document.getElementById("default_button").value = L("Default");
	document.getElementById("twitter_connect_button").value = L("Connect");
	document.getElementById("twitter_enter_button").value = L("Enter");
	document.getElementById("twitter_cancel_button").value = L("Cancel");
	document.getElementById("twitter_unauthorize_button").value = L("Unauthorize");

	// Load preferences
	LoadPreferences();
	SavePreferences(false);

	// Set up selections
	var sel_paused = document.getElementById("select_paused_index");
	var sel_preset = document.getElementById("select_preset_index");

	sel_paused.options.length = g_Conf.preset_count;
	sel_preset.options.length = g_Conf.preset_count;
	for(i=0; i<g_Conf.preset_count; i++)
	{
		sel_paused.options[i].text = i + ": " + g_Conf.preset_text[i];
		sel_paused.options[i].value = i;
		sel_preset.options[i].text = i + ": " + g_Conf.preset_text[i];
		sel_preset.options[i].value = "";
	}

	RestorePreferences();
	UsePresetTextWheniTunesPausesChecked();
	didCheckDelayAutoPost();
	UpdateServicesStatus();

	MoodTextChanged(false);
	EnablePostButton();
}

//////// Called when widget is closed
function Unload()
{
	if(window.itm_plugin)
		window.itm_plugin.RemoveDelegate();
}

//////// Load preferences
function LoadPreferences()
{
	var i, temp;

	if(window.widget)
	{
		g_Conf.format = g_Conf.format_default;
		if(!IsUndefined(temp = widget.preferenceForKey("format")))
			g_Conf.format = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("mood_text_index")))
			g_Conf.mood_text_index = temp;

		if(g_Conf.preset_text[0] == "")
			g_Conf.preset_text[0] = g_Conf.format;

		if(!IsUndefined(temp = widget.preferenceForKey("itunes_paused")))
			g_Conf.itunes_paused = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("paused_index")))
			g_Conf.paused_index = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("use_growl")))
			g_Conf.use_growl = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("delay_auto_post")))
			g_Conf.delay_auto_post = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("delay_auto_post_duration")))
			g_Conf.delay_auto_post_duration = temp;

		for(i in g_Conf.im_services)
		{
			if(!IsUndefined(temp = widget.preferenceForKey("use_" + i)))
				g_Conf.im_services[i].use = temp;
		}

		for(i in g_Conf.post_services)
		{
			if(!IsUndefined(temp = widget.preferenceForKey("use_" + i)))
				g_Conf.post_services[i].use = temp;

			if(!IsUndefined(temp = widget.preferenceForKey(i + "_id")))
				g_Conf.post_services[i].id = temp;

			if(i == "twitter")
			{
				document.getElementById("twitter_id_display").innerHTML = g_Conf.post_services[i].id;
				
				if(!IsUndefined(temp = widget.preferenceForKey(i + "_token")))
					g_Conf.post_services[i].pw = temp;
				
				if(g_Conf.post_services[i].pw != "" && window.itm_plugin.isAuthorized(g_Conf.post_services[i].pw))
				{
					document.getElementById("twitter_unauthorized").style.display = "none";
					document.getElementById("twitter_authorizing").style.display = "none";
					document.getElementById("twitter_authorized").style.display = "block";
				}
			}
			else
			{
				if(!IsUndefined(temp = widget.preferenceForKey(i + "_pw")))
				{
					if(window.itm_plugin && g_Conf.post_services[i].id)
					{
						if(!IsUndefined(temp = window.itm_plugin.GetServicePassword(i, g_Conf.post_services[i].id)))
							g_Conf.post_services[i].pw = temp[0];
					}
				}
			}

			if(!IsUndefined(temp = widget.preferenceForKey(i + "_auto")))
				g_Conf.post_services[i].auto = temp;

			if(!IsUndefined(temp = widget.preferenceForKey(i + "_comment_only")))
				g_Conf.post_services[i].comment_only = temp;
		}

		if(!IsUndefined(temp = widget.preferenceForKey("hashtags")))
		{
			g_Conf.hashtags = temp.split(",");
		}
		
		if(!IsUndefined(temp = widget.preferenceForKey("check_for_updates")))
			g_Conf.check_for_updates = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("last_checked")))
			g_Conf.last_checked = temp;

		for(i=0; i<g_Conf.preset_count; i++)
		{
			if(!IsUndefined(temp = widget.preferenceForKey("preset_text" + i)))
				g_Conf.preset_text[i] = temp;
		}
	}
}

function RestorePreferences()
{
	var i, obj;

	var sel_mood   = document.getElementById("select_mood_text"   );
	var sel_preset = document.getElementById("select_preset_index");

	sel_mood.options.length = g_Conf.preset_count;
	for(i=0; i<g_Conf.preset_count; i++)
	{
		sel_mood  .options[i].text  = i + ": " + g_Conf.preset_text[i];
		sel_mood  .options[i].value = g_Conf.preset_text[i];
		sel_preset.options[i].value = g_Conf.preset_text[i];
	}

	sel_mood.selectedIndex = g_Conf.mood_text_index;
	sel_preset.selectedIndex = g_Conf.preset_index;

	if(obj = document.getElementById("itunes_paused"))
		obj.checked = (g_Conf.itunes_paused? true: false);
	if(obj = document.getElementById("select_paused_index"))
		obj.selectedIndex = g_Conf.paused_index;
	if(obj = document.getElementById("preset_text"))
		obj.value = g_Conf.preset_text[g_Conf.preset_index];
	if(obj = document.getElementById("use_growl"))
		obj.checked = (g_Conf.use_growl? true: false);
	if(obj = document.getElementById("delay_auto_post"))
		obj.checked = (g_Conf.delay_auto_post? true: false);
	if(obj = document.getElementById("select_delay_auto_post"))
		obj.value = g_Conf.delay_auto_post_duration;
	if(obj = document.getElementById("itunes_paused"))
		obj.checked = (g_Conf.itunes_paused? true: false);
	if(obj = document.getElementById("check_for_updates"))
		obj.checked = (g_Conf.check_for_updates? true: false);

	for(i in g_Conf.im_services)
	{
		if(obj = document.getElementById("use_" + i))
			obj.checked = (g_Conf.im_services[i].use? true: false);
	}

	for(i in g_Conf.post_services)
	{
		if(obj = document.getElementById("use_" + i))
			obj.checked = (g_Conf.post_services[i].use? true: false);
		if(obj = document.getElementById(i + "_id"))
			obj.value = g_Conf.post_services[i].id;
		if(obj = document.getElementById(i + "_pw"))
			obj.value = g_Conf.post_services[i].pw;
		if(obj = document.getElementById(i + "_auto"))
			obj.checked = (g_Conf.post_services[i].auto? true: false);
		if(obj = document.getElementById(i + "_comment_only"))
			obj.checked = (g_Conf.post_services[i].comment_only? true: false);
	}
	
	for(i=0; i<g_Conf.hashtags_count; i++)
	{
		if(obj = document.getElementById("hashtag" + (i + 1)))
			obj.checked = false;
	}
	for(i=0; i<g_Conf.hashtags.length; i++)
	{
		if(obj = document.getElementById("hashtag" + g_Conf.hashtags[i]))
			obj.checked = true;
	}
}

//////// Save preferences
function SavePreferences(save_service_password)
{
	var i;

	if(window.widget)
	{
		widget.setPreferenceForKey(g_Conf.mood_text_index  , "mood_text_index"  );
		widget.setPreferenceForKey(g_Conf.itunes_paused    , "itunes_paused"    );
		widget.setPreferenceForKey(g_Conf.paused_index     , "paused_index"     );
		widget.setPreferenceForKey(g_Conf.use_growl        , "use_growl"        );
		widget.setPreferenceForKey(g_Conf.delay_auto_post  , "delay_auto_post"  );
		widget.setPreferenceForKey(g_Conf.delay_auto_post_duration, "delay_auto_post_duration");
		widget.setPreferenceForKey(g_Conf.check_for_updates, "check_for_updates");
		widget.setPreferenceForKey(g_Conf.last_checked     , "last_checked"     );

		widget.setPreferenceForKey(g_Conf.format           , "format"           );
		for(i=0; i<g_Conf.preset_count; i++)
		{
			widget.setPreferenceForKey(g_Conf.preset_text[i], "preset_text" + i  );
		}

		for(i in g_Conf.im_services)
		{
			widget.setPreferenceForKey(g_Conf.im_services[i].use, "use_" + i);
		}

		for(i in g_Conf.post_services)
		{
			widget.setPreferenceForKey(g_Conf.post_services[i].use         , "use_" + i         );
			widget.setPreferenceForKey(g_Conf.post_services[i].id          , i + "_id"          );
			if(i == "twitter")
			{
				widget.setPreferenceForKey(g_Conf.post_services[i].pw, i + "_token");
			}
			else
			{
				widget.setPreferenceForKey(g_Conf.post_services[i].pw? "*": "" , i + "_pw");
				if(window.itm_plugin && (save_service_password == null || save_service_password))
				{
					if(g_Conf.post_services[i].use && g_Conf.post_services[i].id)
						window.itm_plugin.SetServicePassword(i, g_Conf.post_services[i].id, g_Conf.post_services[i].pw);
				}
			}
			widget.setPreferenceForKey(g_Conf.post_services[i].auto        , i + "_auto"        );
			widget.setPreferenceForKey(g_Conf.post_services[i].comment_only, i + "_comment_only");
		}
		
		widget.setPreferenceForKey(g_Conf.hashtags.join(","), "hashtags");
	}
}

function StorePreferences()
{
	var i, obj;

	var sel_mood   = document.getElementById("select_mood_text"   );
	var sel_preset = document.getElementById("select_preset_index");

	for(i=0; i<g_Conf.preset_count; i++)
	{
		sel_mood.options[i].text = i + ": " + sel_preset.options[i].value;
		sel_mood.options[i].value = sel_preset.options[i].value;
		g_Conf.preset_text[i] = sel_preset.options[i].value;
	}
	g_Conf.format = g_Conf.preset_text[g_Conf.mood_text_index];

	g_Conf.mood_text_index = sel_mood.selectedIndex;
	g_Conf.preset_index    = sel_preset.selectedIndex;

	if(obj = document.getElementById("itunes_paused"))
		g_Conf.itunes_paused = (obj.checked? 1: 0);
	if(obj = document.getElementById("select_paused_index"))
		g_Conf.paused_index = obj.selectedIndex;
	if(obj = document.getElementById("use_growl"))
		g_Conf.use_growl = (obj.checked? 1: 0);
	if(obj = document.getElementById("delay_auto_post"))
		g_Conf.delay_auto_post = (obj.checked? 1: 0);
	if(obj = document.getElementById("select_delay_auto_post"))
		g_Conf.delay_auto_post_duration = obj.value;
	if(obj = document.getElementById("check_for_updates"))
		g_Conf.check_for_updates = (obj.checked? 1: 0);

	for(i in g_Conf.im_services)
	{
		if(obj = document.getElementById("use_" + i))
			g_Conf.im_services[i].use = (obj.checked? 1: 0);
	}

	for(i in g_Conf.post_services)
	{
		if(obj = document.getElementById("use_" + i))
			g_Conf.post_services[i].use = (obj.checked? 1: 0);
		if(obj = document.getElementById(i + "_id"))
			g_Conf.post_services[i].id = obj.value;
		if(obj = document.getElementById(i + "_pw"))
			g_Conf.post_services[i].pw = obj.value;
		if(obj = document.getElementById(i + "_auto"))
			g_Conf.post_services[i].auto = (obj.checked? 1: 0);
		if(obj = document.getElementById(i + "_comment_only"))
			g_Conf.post_services[i].comment_only = (obj.checked? 1: 0);
	}
	
	g_Conf.hashtags = [];
	for(i=0; i<g_Conf.hashtags_count; i++)
	{
		if(obj = document.getElementById("hashtag" + (i + 1)))
		{
			if(obj.checked)
				g_Conf.hashtags.push(i + 1);
		}
	}
}

//////// Show mood text selection
function ShowSelectMoodText()
{
	if(g_bSelectMoodTextShown) return;

	if(g_SelectMoodTextAnimator)
	{
		g_SelectMoodTextAnimator.stop();
		delete g_SelectMoodTextAnimator;
		delete g_SelectMoodTextAnimation;
		g_SelectMoodTextAnimator = null;
		g_SelectMoodTextAnimation = null;
	}

	document.getElementById("info").className = "select_shown";

	g_bSelectMoodTextShown = true;

	g_SelectMoodTextAnimator = new AppleAnimator(500, 13);
	g_SelectMoodTextAnimator.oncomplete = SelectMoodText_AnimationComplete;
	g_SelectMoodTextAnimation = new AppleAnimation(0.0, 1.0, SelectMoodText_UpdateOpacity);
	g_SelectMoodTextAnimator.addAnimation(g_SelectMoodTextAnimation);
	g_SelectMoodTextAnimator.start();
}

//////// Hide mood text selection
function HideSelectMoodText()
{
	if(!g_bSelectMoodTextShown) return;

	if(g_SelectMoodTextAnimator)
	{
		g_SelectMoodTextAnimator.stop();
		delete g_SelectMoodTextAnimator;
		delete g_SelectMoodTextAnimation;
		g_SelectMoodTextAnimator = null;
		g_SelectMoodTextAnimation = null;
	}

	g_bSelectMoodTextShown = false;

	g_SelectMoodTextAnimator = new AppleAnimator(500, 13);
	g_SelectMoodTextAnimator.oncomplete = SelectMoodText_AnimationComplete;
	g_SelectMoodTextAnimation = new AppleAnimation(1.0, 0.0, SelectMoodText_UpdateOpacity);
	g_SelectMoodTextAnimator.addAnimation(g_SelectMoodTextAnimation);
	g_SelectMoodTextAnimator.start();
}

//////// Handler for animation
function SelectMoodText_UpdateOpacity(animation, now, first, done)
{
	document.getElementById("select_bg").style.opacity = now;
}

//////// Handler for animation
function SelectMoodText_AnimationComplete()
{
	delete g_SelectMoodTextAnimator;
	delete g_SelectMoodTextAnimation;
	g_SelectMoodTextAnimator = null;
	g_SelectMoodTextAnimation = null;

	if(!g_bSelectMoodTextShown)
		document.getElementById("info").className = "";
}

//////// Mood text selection changed
function MoodTextChanged()
{
	var sel_mood = document.getElementById("select_mood_text");

	g_Conf.format = sel_mood.value;
	g_Conf.mood_text_index = sel_mood.selectedIndex;
	if(window.widget)
	{
		widget.setPreferenceForKey(g_Conf.format, "format");
		widget.setPreferenceForKey(g_Conf.mood_text_index, "mood_text_index");
	}

	SetMoodText();
}

//////// Show preferences
function ShowPrefs()
{
	window.resizeBy(0, g_Conf.back_height - (g_Conf.front_height + (IsPostServiceEnabled()? g_Conf.post_offset: 0)));

	if(window.widget)
		widget.prepareForTransition("ToBack");

	document.getElementById("front").style.display = "none";
	document.getElementById("back" ).style.display = "block";

	if(window.widget)
		window.setTimeout(function(){widget.performTransition();}, 0);
}

//////// Hide preferences
function HidePrefs()
{
	if(window.widget)
		widget.prepareForTransition("ToFront");

	document.getElementById("front").style.display = "block";
	document.getElementById("back" ).style.display = "none";

	if(window.widget)
		window.setTimeout(function(){widget.performTransition();}, 0);

	window.resizeBy(0, (g_Conf.front_height + (IsPostServiceEnabled()? g_Conf.post_offset: 0) - g_Conf.back_height));
	g_InfoButton._frontOutDelay();
	g_InfoButton._labelOut();
}

//////// Hide preferences and cancel changes
function HidePrefsWithoutApplyChanges()
{
	RestorePreferences();
	HidePrefs();
	UsePresetTextWheniTunesPausesChecked();
	didCheckDelayAutoPost();
	UpdateServicesStatus();
}

//////// Hide preferences and apply changes
function HidePrefsWithApplyChanges()
{
	StorePreferences();
	SavePreferences();
	HidePrefs();
	
	g_Conf.cancel_auto_posting = 1;
	
	SetMoodText();
	UpdatePostButton("");
	EnablePostButton();
}

//////// Event handlers for back side
function UsePresetTextWheniTunesPausesChecked()
{
	var flag = document.getElementById("itunes_paused").checked;
	document.getElementById("select_paused_index").disabled = !flag;
}

function PresetIndexChanged()
{
	var sel_preset = document.getElementById("select_preset_index");

	g_Conf.preset_index = sel_preset.selectedIndex;
	document.getElementById("preset_text").value = sel_preset.value;
}

function PresetTextUpdated()
{
	document.getElementById("select_preset_index").options[g_Conf.preset_index].value = document.getElementById("preset_text").value;
}

function PrefsTabMouseOver(e, obj)
{
	if(!HasClassName(obj, "active"))
		AddClassName(obj, "over");
}

function PrefsTabMouseOut(e, obj)
{
	if(!HasClassName(obj, "active"))
		RemoveClassName(obj, "over");
}

function PrefsTabClicked(index)
{
	for(var i=1; i<=g_Conf.prefs_tab_count; i++)
	{
		if(i != index)
		{
			RemoveClassName(document.getElementById("tab" + i), "active", "over");
		}
	}

	document.getElementById("tab" + g_nPrefsTabIndex + "_content").style.display = "none";
	g_nPrefsTabIndex = index;
	AddClassName(document.getElementById("tab" + g_nPrefsTabIndex), "active");
	document.getElementById("tab" + g_nPrefsTabIndex + "_content").style.display = "block";
}

function UsePostServiceChecked(service_name)
{
	var obj, flag = false;

	if(obj = document.getElementById("use_" + service_name))
		flag = obj.checked;

	if(obj = document.getElementById(service_name + "_info"))
		(!flag? AddClassName(obj, "disabled"): RemoveClassName(obj, "disabled"));
	if(obj = document.getElementById(service_name + "_id"))
		obj.disabled = !flag;
	if(obj = document.getElementById(service_name + "_pw"))
		obj.disabled = !flag;
	if(obj = document.getElementById(service_name + "_auto"))
		obj.disabled = !flag;
	if(obj = document.getElementById(service_name + "_comment_only"))
		obj.disabled = !flag;
}

function UpdateServicesStatus()
{
	for(i in g_Conf.post_services)
	{
		UsePostServiceChecked(i);
	}
}

function didCheckDelayAutoPost()
{
	var flag = document.getElementById("delay_auto_post").checked;
	document.getElementById("select_delay_auto_post").disabled = !flag;
}

//////// Set format to default setting
function SetFormatDefault()
{
	document.getElementById("preset_text").value = g_Conf.format_default;
	document.getElementById("select_preset_index").options[g_Conf.preset_index].value = g_Conf.format_default;
}

//////// Set mood text
function SetMoodText()
{
	if(!window.widget)
		return;

	// Get track information and set mood text
	if(window.itm_plugin)
		window.itm_plugin.UpdateMoodText();
}


function organizeHashtags()
{
	var hashtags = [];
	for(var i=0; i<g_Conf.hashtags.length; i++)
	{
		if(g_Conf.hashtags[i] == 1)
		{
			var hashtag = g_Conf.current_artist.toLowerCase().replace(new RegExp(g_Conf.characters_removed_from_hashtag, "g"), "");
			if(hashtag != "")
			{
				hashtags.push("#" + hashtag);
			}
		}
		else if(g_Conf.hashtags[i] == 2)
		{
			var hashtag = g_Conf.current_album.toLowerCase().replace(new RegExp(g_Conf.characters_removed_from_hashtag, "g"), "");
			if(hashtag != "")
			{
				hashtags.push("#" + hashtag);
			}
		}
		else if(g_Conf.hashtags[i] == 3)
		{
			var hashtag = g_Conf.current_genre.toLowerCase().replace(new RegExp(g_Conf.characters_removed_from_hashtag, "g"), "");
			if(hashtag != "")
			{
				hashtags.push("#" + hashtag);
			}
		}
		else if(g_Conf.hashtags[i] == 4)
		{
			hashtags.push("#inthemood");
		}
		else if(g_Conf.hashtags[i] == 5)
		{
			hashtags.push("#nowplaying");
		}
	}
	
	return hashtags.join(" ");
}


//////// Called by itm.widgetplugin
function MoodTextUpdated(state, name, artist, album, genre, str)
{
	if(g_delayAutoPostTimer != null)
		window.clearTimeout(g_delayAutoPostTimer);
	
	var str = (IsUndefined(str)? "": str);
	document.getElementById("info").innerText = str;
	
	var auto_posting = (g_Conf.mood_text != str && state == "Playing" && !g_Conf.cancel_auto_posting);
	
	g_Conf.mood_text = str;
	g_Conf.current_song = name;
	g_Conf.current_artist = artist;
	g_Conf.current_album = album;
	g_Conf.current_genre = genre;
	
	g_Conf.short_artist = blipfmRemoveAdditionalStringFrom(artist, true);
	g_Conf.short_title = blipfmRemoveAdditionalStringFrom(name, true);
	
	var hashtags = organizeHashtags();
	if(hashtags != "")
	{
		str += " " + hashtags;
	}
	
	if(auto_posting && IsPostServiceEnabled())
	{
		if(g_Conf.delay_auto_post)
		{
			g_delayAutoPostTimer = window.setTimeout(function(){ BeginPostMoodText(str, true); }, g_Conf.delay_auto_post_duration * 1000);
		}
		else
		{
			BeginPostMoodText(str, true);
		}
	}
	
	g_Conf.cancel_auto_posting = 0;
}

//////// For post services
function IsPostServiceEnabled()
{
	var i, ret = false;
	for(i in g_Conf.post_services)
	{
		ret |= g_Conf.post_services[i].use;
	}

	return ret;
}

function IsPostRequestBusy()
{
	var i, ret = false;
	for(i in g_PostRequest)
	{
		ret |= (g_PostRequest[i] != null);
	}

	return ret;
}

function EnablePostButton()
{
	var flag = IsPostServiceEnabled();

	window.resizeTo(g_Conf.width, g_Conf.front_height + (flag? g_Conf.post_offset: 0));
	document.getElementById("front").className = (flag? "post_service_enabled": "");
}

function PostButtonMouseOver(event, id)
{
	g_nPostButtonStatus = 1;
	if(!IsPostRequestBusy())
	{
		RemoveClassName(event.target, "loading");
		RemoveClassName(event.target, "down");
		AddClassName(event.target, "over");
	}
}

function PostButtonMouseOut(event, id)
{
	g_nPostButtonStatus = 0;
	if(!IsPostRequestBusy())
	{
		RemoveClassName(event.target, "over");
	}
}

function PostButtonMouseDown(event, id)
{
	if(!IsPostRequestBusy())
	{
		RemoveClassName(event.target, "loading");
		RemoveClassName(event.target, "over");
		AddClassName(event.target, "down");
	}
}

function PostButtonClicked()
{
	if(IsPostServiceEnabled())
	{
		var str = g_Conf.mood_text;
		
		var prefix = document.getElementById("post_prefix").value;
		if(prefix != "")
		{
			str = prefix + " " + str;
		}
		
		var hashtags = organizeHashtags();
		if(hashtags != "")
		{
			str += " " + hashtags;
		}
	
		BeginPostMoodText(str);
	}
}

function PostPrefixEntered()
{
	if(IsPostServiceEnabled())
		PostButtonClicked();

	return false;
}

function BeginPostMoodText(str, auto)
{
	var i;

	g_PostErrors = [];
	for(i in g_Conf.post_services)
	{
		var service = g_Conf.post_services[i];
		if(service.use)
		{
			if(!auto || (auto && service.auto))
			{
				var obj;
				if(obj = document.getElementById("post_button"))
				{
					window.setTimeout(function(){
						RemoveClassName(obj, "over");
						RemoveClassName(obj, "down");
						AddClassName(obj, "loading");
					}, 0);
				}

				g_nPostCount++;
				if(service.name == "blipfm")
				{
					BlipFm_PostMoodText(service, str);
				}
				else
				{
					PostMoodText(service, str);
				}
			}
		}
	}
}

function EndPostMoodText()
{
	if(g_PostErrors.length < 1)
	{
		UpdatePostButton();
		document.getElementById("post_prefix").value = "";
	}
	else
	{
		UpdatePostButton(g_PostErrors.join("\n"));
	}
}

function PostMoodText(service, str, blipfm_params, blipfm_song)
{
	if(!service) return;

	if(g_PostRequest[service.name])
	{
		g_PostRequest[service.name].abort();
		delete g_PostRequest[service.name];
		g_PostRequest[service.name] = null;
	}

	g_PostRequest[service.name] = new XMLHttpRequest();
	if(g_PostRequest[service.name])
	{
		var url = service.url;
		var params = "", id, pw;

		if(service.comment_only)
		{
			var prefix = document.getElementById("post_prefix").value;
			if(prefix != "")
				str = prefix;
		}

		if(service.name == "blipfm")
		{
			if(str == "")
				str = " ";

			params  = "artist=" + encodeURIComponent(g_Conf.current_artist);
			params += "&title=" + encodeURIComponent(g_Conf.current_song);
			params += "&url=" + blipfm_song.location;
			params += "&blipType=" + blipfm_song.type;
			params += "&message=" + encodeURIComponent(str.substr(0, service.max_length));
			params += "&timestamp=" + blipfm_params.timestamp;
			params += "&nonce=" + blipfm_params.nonce;
			params += "&signature=" + blipfm_params.signature;
			if(blipfm_params.auth)
			{
				id = null;
				pw = null;
			}
			else
			{
				id = service.id;
				pw = service.pw;
			}
		}
		else if(service.name == "friendfeed")
		{
			params  = "title=" + encodeURIComponent(str.substr(0, service.max_length));
			id = service.id;
			pw = service.pw;
		}
		else if(service.name == "jaiku")
		{
			params  = "user=" + encodeURIComponent(service.id);
			params += "&personal_key=" + encodeURIComponent(service.pw);
			params += "&message=" + encodeURIComponent(str.substr(0, service.max_length));
			id = null;
			pw = null;
		}
		else if(service.name == "twitter")
		{
			updateStatus(str.substr(0, service.max_length), "");
			return;
		}
		else if(service.name == "wassr")
		{
			params  = "status=" + encodeURIComponent(str.substr(0, service.max_length));
			params += "&source=" + encodeURIComponent(g_Conf.app_name);
			id = service.id;
			pw = service.pw;
		}

		if(service.params != "")
			params += "&" + service.params;

		g_PostRequest[service.name].onload = function(e){PostMoodTextDone(g_PostRequest[service.name], service);};
		g_PostRequest[service.name].open("POST", url, true, id, pw);
		if(blipfm_params && blipfm_params.auth)
		{
			var host = url.replace(/^https?\:\/\/|\/.+$/g, "");
			var uri = url.replace(/^https?\:\/\/[^\/]+/, "");
			g_PostRequest[service.name].setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
			g_PostRequest[service.name].setRequestHeader("Host", host);
			g_PostRequest[service.name].setRequestHeader("Authorization", blipfm_params.auth);
		}
		g_PostRequest[service.name].setRequestHeader("Cache-Control", "no-cache");
		g_PostRequest[service.name].setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		g_PostRequest[service.name].setRequestHeader("Content-Length", params.length);
		g_PostRequest[service.name].send(params);

		g_PostTimer[service.name] = window.setTimeout(function(){PostTimedOut(service);}, g_Conf.post_timeout * 1000);
	}
}

function PostMoodTextDone(request, service)
{
	if(g_PostTimer[service.name])
	{
		window.clearTimeout(g_PostTimer[service.name]);
		g_PostTimer[service.name] = null;
	}

	if(request.status == 200)
	{
		// OK
	}
	else
	{
		// Some error occurred
		var error;
		if(service.name == "blipfm")
		{
			var result = eval("(" + request.responseText + ")")
			if(result.status.code == "111")
				;
			else if(result.error)
				pushError(service, result.error.message, result.error.code);
			else if(result.status)
				pushError(service, result.status.message, result.status.code);
		}
		else if(service.name == "friendfeed")
		{
			var result = eval("(" + request.responseText + ")")
			if(result.errorCode)
				pushError(service, g_Conf.post_error[999], result.errorCode);
		}
		else
		{
			if(g_Conf.post_error[request.status])
			{
				pushError(service, g_Conf.post_error[request.status], request.status);
			}
			else
			{
				pushError(service, g_Conf.post_error[999], request.status);
			}
		}
	}

	PostMoodTextFinished(service);
}

function PostTimedOut(service)
{
	if(g_PostTimer[service.name])
	{
		window.clearTimeout(g_PostTimer[service.name]);
		g_PostTimer[service.name] = null;
	}

	g_PostErrors.push("[" + service.label + "] " + g_Conf.post_error[998]);

	PostMoodTextFinished(service);
}

function PostMoodTextFinished(service)
{
	if(g_PostRequest[service.name])
	{
		g_PostRequest[service.name].abort();
		delete g_PostRequest[service.name];
		g_PostRequest[service.name] = null;
	}

	if(--g_nPostCount < 1)
		EndPostMoodText();
}

function pushError(service, message, code)
{
	g_PostErrors.push("[" + service.label + (code? ":" + code: "") + "] " + message);
}

function UpdatePostButton(error)
{
	var obj;
	if(obj = document.getElementById("post_button"))
	{
		window.setTimeout(function(){
			RemoveClassName(obj, "loading");
			RemoveClassName(obj, "down");

			if(g_nPostButtonStatus)
				AddClassName(obj, "over");
			else
				RemoveClassName(obj, "over");

			if(error)
				AddClassName(obj, "error");
			else
				RemoveClassName(obj, "error");
		}, 500);

		obj.title = (error? error: "");
	}
}


//// Request to Twitter
function verifyCredentials()
{
	if(window.itm_plugin)
	{
		window.itm_plugin.verifyCredentials();
	}
}


function verifyCredentialsDidFinish(error, result)
{
	var response = null;
	if(result)
		response = evalResponse(result);
	
	if(error != 0)
	{
		var errorString = (response? (response.error? response.error: response): "");
		displayErrorInline(document.getElementById("twitter_info"), errorString);
		return;
	}
	
	var service = g_Conf.post_services["twitter"];
	service.id = response.screen_name;
	document.getElementById("twitter_id").value = service.id;
	document.getElementById("twitter_id_display").innerHTML = service.id;
}


function updateStatus(status, status_id)
{
	if(window.itm_plugin)
		window.itm_plugin.updateStatus(status, status_id);
}


function updateStatusDidFinish(error, result)
{
	var response = null;
	if(result)
		response = evalResponse(result);
	
	var service = g_Conf.post_services["twitter"];
	
	if(error != 0)
	{
		var errorString = g_Conf.post_error[999];
		if(response)
		{
			if(response.errors)
			{
				for(i=0; i<response.errors.length; i++)
				{
					pushError(service, response.errors[i].message, response.errors[i].code);
				}
			}
			else if(response.error)
			{
				pushError(service, response.error);
			}
			else
			{
				pushError(service, response);
			}
		}
		else
		{
			pushError(service, g_Conf.post_error[999]);
		}
	}

	PostMoodTextFinished(service);
}

	
//// For authorization
function requestRequestToken()
{
	if(window.itm_plugin)
		window.itm_plugin.requestRequestToken();
}


function requestRequestTokenDidFinish(error, result)
{
	var response = null;
	if(result)
		response = evalResponse(result);
	
	if(error != 0)
	{
		var errorString = (response? (response.error? response.error: response): "");
		displayErrorInline(document.getElementById("twitter_info"), errorString);
		return;
	}
	
	document.getElementById("twitter_unauthorized").style.display = "none";
	document.getElementById("twitter_authorizing").style.display = "block";
	document.getElementById("twitter_verifier").focus();
	
	if(window.itm_plugin)
		window.itm_plugin.redirectToAuthorizeURL();
}


function requestAccessToken()
{
	var verifier = document.getElementById("twitter_verifier");
	if(window.itm_plugin)
		window.itm_plugin.requestAccessToken(verifier.value);
	verifier.value = "";
}


function requestAccessTokenDidFinish(error, result)
{
	var response = null;
	if(result)
		response = evalResponse(result);
	
	if(error != 0)
	{
		var errorString = (response? (response.error? response.error: response): "");
		displayErrorInline(document.getElementById("twitter_info"), errorString);
		return;
	}
	
	document.getElementById("twitter_authorizing").style.display = "none";
	document.getElementById("twitter_authorized").style.display = "block";
	
	var service = g_Conf.post_services["twitter"];
	service.pw = result;
	document.getElementById("twitter_pw").value = service.pw;
	
	window.setTimeout(function(){ verifyCredentials(); }, 0);
}


//// For Blip.fm
function BlipFm_GetParams(method, callback)
{
	var service = g_Conf.post_services["blipfm"];
	var url = service.url_getparams + "?method=" + method;
	var request = new XMLHttpRequest();
	request.onload = function(e){
		if(request.status == 200)
		{
			var params = eval("(" + request.responseText + ")");
			callback(params);
		}
		else
		{
			callback(null);
		}
	};
	request.open("GET", url, true);
	request.setRequestHeader("Cache-Control", "no-cache");
	request.send(null);
}

function BlipFm_GetAuthString(method, url)
{
	var host = url.replace(/^https?\:\/\/|\/.+$/g, "");
	var uri = url.replace(/^https?\:\/\/[^\/]+/, "");

	var request = new XMLHttpRequest();
	request.open(method, url, false);
	request.setRequestHeader("Method", method + " " + uri + " HTTP/1.1");
	request.setRequestHeader("Host", host, "");
	request.setRequestHeader("Cache-Control", "no-cache");
	if(method == "POST")
	{
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.setRequestHeader("Content-Length", 0);
	}
	request.send(null);

	if(request.status != 401)
		return null;

	var header = request.getResponseHeader("WWW-Authenticate");
	if(!header.match(/^Digest (.+)$/))
		return null;

	var temp = (header.replace(/^.+?\s/, "")).split(",");
	var params = {};
	for(var i=0; i<temp.length; i++)
	{
		var pair = temp[i].replace(/^\s+|\s+$/g, "").split("=");
		params[pair[0]] = pair[1].replace(/^"|"$/g, "");
	}

	var service = g_Conf.post_services["blipfm"];

	var nc = Number(++g_nBlipCount).toString(16);
	nc = "0000000" + nc;
	nc = nc.substr(nc.length - 8, 8);
	var cnonce = Md5((new Date).getTime());
	var qop = "auth";
	var response;

	response  = Md5(service.id + ":" + params.realm + ":" + service.pw);
	response += ":" + params.nonce + ":" + nc + ":" + cnonce + ":" + qop + ":";
	response += Md5(method + ":" + uri);
	response  = Md5(response);

	var ret = "Digest username=\"" + service.id + "\"";
	ret += ", realm=\"" + params.realm + "\", uri=\"" + uri + "\"";
	ret += ", nonce=\"" + params.nonce + "\", nc=" + nc + ", cnonce=\"" + cnonce + "\""
	ret += ", qop=" + qop;
	if(!IsNull(params.opaque))
		ret += ", opaque=\"" + params.opaque + "\"";
	ret += ", response=\"" + response + "\"";
	return ret;
}

function BlipFm_FindSongs(name, artist, params, callback)
{
	name = name.replace(/\//g, " ");
	artist = artist.replace(/\//g, " ");
	
	var service = g_Conf.post_services["blipfm"];
	var url = service.url_findsongs + "?" + service.params;
	url += "&searchTerm=" + encodeURIComponent(artist + " " + name);
	url += "&timestamp=" + params.timestamp;
	url += "&nonce=" + params.nonce;
	url += "&signature=" + params.signature;

	var request = new XMLHttpRequest();
	request.onload = function(e){
		if(request.status == 200)
		{
			var songs = eval("(" + request.responseText + ")");
			callback(songs);
		}
		else
		{
			callback(null);
		}
	};
	request.open("GET", url, false);
	request.setRequestHeader("Cache-Control", "no-cache");
	request.send(null);
}

function BlipFm_GetSong(name, artist, callback)
{
	var result = {"location":"unavailable", "type":"songUrl"};
	BlipFm_GetParams("GET", function(params){
		BlipFm_FindSongs(name, artist, params, function(songs){
			if(songs && songs.status && songs.status.code == "200" && songs.result)
			{
				if(songs.result.count > 0)
				{
					var song;
					for(var i=0; i<songs.result.count; i++)
					{
						song = songs.result.collection.Song[i];
						if(song.location != "" && song.location != "unavailable" && BlipFm_IsSongEqualTo(song, artist, name))
						{
							callback(song);
							return;
						}
					}
				}
			}

			callback(result);
			return;
		});
	});
}

function BlipFm_IsSongEqualTo(song, artist, title)
{
	var check_artist, check_title, pattern_artist, pattern_title;
	
	pattern_artist = new RegExp(blipfmPatternStringFrom(QuoteMeta(artist)), "i");
	pattern_title = new RegExp(blipfmPatternStringFrom(QuoteMeta(title)), "i");

	if(song.title == "" || song.title.match(/^untitled$/i))
	{
		check_title = blipfmRemoveAdditionalStringFrom(decodeURIComponent(song.location), false);
	}
	else
	{
		check_title = blipfmRemoveAdditionalStringFrom(song.title, false);
	}

	if(song.artist == "" || song.artist.match(/^no artist$/i))
	{
		check_artist = check_title;
	}
	else
	{
		check_artist = blipfmRemoveAdditionalStringFrom(song.artist, false);
	}

	return (check_artist.match(pattern_artist) && check_title.match(pattern_title));
}

function BlipFm_PostMoodText(service, str)
{
	BlipFm_GetSong(g_Conf.short_title, g_Conf.short_artist, function(song){
		if(!IsNull(song))
		{
			if(song.location != "" && song.location != "unavailable")
			{
				BlipFm_GetParams("POST", function(params){
					params.auth = BlipFm_GetAuthString("POST", service.url);
					PostMoodText(service, str, params, song);
				});
			}
			else
			{
				pushError(service, g_Conf.post_error[997]);
				PostMoodTextFinished(service);
			}
		}
	});
}

//////// Check for updates
function CheckForUpdates()
{
	if(!g_Conf.check_for_updates)
		return;

	var date = new Date();
	if(date.getTime() <= g_Conf.last_checked + g_Conf.check_for_upd_every * 1000)
		return;

	g_Conf.last_checked = date.getTime();
	SavePreferences();

	if(g_CheckForUpdatesRequest)
	{
		g_CheckForUpdatesRequest.abort();
		delete g_CheckForUpdatesRequest;
		g_CheckForUpdatesRequest = null;
	}

	g_CheckForUpdatesRequest = new XMLHttpRequest();
	if(g_CheckForUpdatesRequest)
	{
		g_CheckForUpdatesRequest.onload = function(e){CheckForUpdatesDone(g_CheckForUpdatesRequest);};
		g_CheckForUpdatesRequest.open("GET", g_Conf.check_for_upd_url, true);
		g_CheckForUpdatesRequest.setRequestHeader("Cache-Control", "no-cache");
		g_CheckForUpdatesRequest.send("");

		g_CheckForUpdatesTimer = window.setTimeout(function(){CheckForUpdatesTimedOut();}, g_Conf.check_for_upd_timeout * 1000);
	}
}

function CheckForUpdatesDone(request)
{
	if(g_CheckForUpdatesTimer)
	{
		window.clearTimeout(g_CheckForUpdatesTimer);
		g_CheckForUpdatesTimer = null;
	}

	if(request.status == 200)
	{
		var ver_local = {ver:0, beta:0}, ver_server = {ver:0, beta:0};
		
		if(g_Conf.version.match(/ver\.([\d.]+)(b(\d+))?/))
		{
			ver_local.ver = RegExp.$1;
			ver_local.beta = RegExp.$3;
		}

		if(request.responseText.match(/ver\.([\d.]+)(b(\d+))?/))
		{
			ver_server.ver = RegExp.$1;
			ver_server.beta = RegExp.$3;
		}

		if(
			(ver_server.ver > ver_local.ver) || 
			(ver_server.ver == ver_local.ver && ((!ver_server.beta && ver_local.beta) || (ver_server.beta > ver_local.beta)))
		)
		{
			// New version found
			document.getElementById("updated_button").style.display = "block";
		}
	}

	if(g_CheckForUpdatesRequest)
	{
		delete g_CheckForUpdatesRequest;
		g_CheckForUpdatesRequest = null;
	}
}

function CheckForUpdatesTimedOut()
{
	if(g_CheckForUpdatesTimer)
	{
		window.clearTimeout(g_CheckForUpdatesTimer);
		g_CheckForUpdatesTimer = null;
	}

	if(g_CheckForUpdatesRequest)
	{
		g_CheckForUpdatesRequest.abort();
		delete g_CheckForUpdatesRequest;
		g_CheckForUpdatesRequest = null;
	}
}

function UpdatedButtonClicked()
{
	if(window.widget)
		window.widget.openURL("http://www.mybdesign.com/itm/");
}


//////// Event handlers
function didClickTwitterConnectButton()
{
	requestRequestToken();
}


function didClickTwitterEnterButton()
{
	requestAccessToken();
}


function didClickTwitterCancelButton()
{
	didClickTwitterUnauthorizeButton();
}


function didClickTwitterUnauthorizeButton()
{
	var service = g_Conf.post_services["twitter"];
	service.id = "";
	service.pw = "";
	
	var obj;
	if(obj = document.getElementById("twitter_id"))
		obj.value = "";
	if(obj = document.getElementById("twitter_pw"))
		obj.value = "";
	
	SavePreferences(false);
	
	document.getElementById("twitter_id_display").innerHTML = "";
	document.getElementById("twitter_authorized").style.display = "none";
	document.getElementById("twitter_authorizing").style.display = "none";
	document.getElementById("twitter_unauthorized").style.display = "block";
}


//////// Common functions
function IsNull(obj)
{
	return (obj == null);
}

function IsUndefined(obj)
{
	return (typeof(obj) == "undefined");
}

function HasClassName(obj, name)
{
	var regexp = new RegExp("\\b" + name + "\\b");
	return obj.className.match(regexp);
}

function AddClassName(obj)
{
	for(var i=1; i<arguments.length; i++)
	{
		if(!HasClassName(obj, arguments[i]))
			obj.className += (obj.className? " ": "") + arguments[i];
	}
}

function RemoveClassName(obj)
{
	for(var i=1; i<arguments.length; i++)
	{
		var regexp = new RegExp("^" + arguments[i] + "\\s*|\\s*" + arguments[i] + "\\b");
		obj.className = obj.className.replace(regexp, "");
	}
}

function QuoteMeta(str)
{
	return str.replace(/([.\/\\+*?\[^\]($)|])/g, "\\$1");
}

function Md5(str)
{
	str = String(str).replace(/([\"\`\$\\])/g, function(){ return "\\" + RegExp.$1; });	//"
	var ret = (widget.system("/sbin/md5 -s \"" + str + "\"", null)).outputString;
	if(ret.match(/(\S+)\s*$/))
		return RegExp.$1;
	else
		return "";
}


function blipfmPatternStringFrom(source)
{
	var ret = source.replace(/[\s\-_]/g, "[\\s\\-_]?");
	ret = ret.replace(new RegExp("'", "g"), "'?");
	ret = ret.replace(/!/g, "!?");
	ret = ret.replace(/\\\./g, "\\.?");
	ret = ret.replace(/\\\?/g, "\\??");
	ret = ret.replace(/\\\//g, "\\s*[\\-\\/]\\s*");
	ret = ret.replace(/[aàáäâãå]/gi, "[aàáäâãå]");
	ret = ret.replace(/(ae|æ)/gi, "(ae|æ)");
	ret = ret.replace(/[cç]/gi, "[cç]");
	ret = ret.replace(/[eèéëê]/gi, "[eèéëê]");
	ret = ret.replace(/[iìíïî]/gi, "[iìíïî]");
	ret = ret.replace(/[nñ]/gi, "[nñ]");
	ret = ret.replace(/[oòóöôõø]/gi, "[oòóöôõø]");
	ret = ret.replace(/(oe|œ)/gi, "(oe|œ)");
	ret = ret.replace(/[uùúüû]/gi, "[uùúüû]");
	ret = ret.replace(/[yÿ]/gi, "[yÿ]");
	return ret;
}


function blipfmRemoveAdditionalStringFrom(source, deeply)
{
	var ret = source.replace(/\s*(\([^\)]+\)|\[[^\]]+\])/g, "");
	
	if(deeply)
		ret = ret.replace(/ - .+$/, "");
	
	return ret;
}


function displayErrorInline(element, error)
{
	var errorElement = document.createElement("DIV");
	errorElement.className = "inline_error";
	errorElement.appendChild(document.createTextNode(error));
	element.appendChild(errorElement);
	
	window.setTimeout(function(){
		var animator = new AppleAnimator(200, 13);
		animator.oncomplete = function(){ element.removeChild(errorElement); };
		var animation = new AppleAnimation(1, 0, function(animator, current, start, finish){
			errorElement.style.opacity = current;
		});
		animator.addAnimation(animation);
		animator.start();
	}, 5000);
}


function evalResponse(response)
{
	if(response.match(/^<!DOCTYPE/) && response.match(/var twttr = \{\};\s+twttr\.translations = (\{(.|\s)+?\});/))
	{
		try
		{
			var translations = eval("(" + RegExp.$1 + ")");
			var language = window.navigator.language.toLowerCase().substr(0, 2);
			if(translations[language])
				return translations[language].title;
			else
				return translations["en"].title;
		}
		catch(e)
		{
			return null;
		}
	}
	else
	{
		try
		{
			return eval("(" + response + ")");
		}
		catch(e)
		{
			return evalResponse("\"" + response + "\"");
		}
	}
}


//// Get localized string
function L(text)
{
	if(window.dashcode)
		return window.dashcode.getLocalizedString(text);
	else
		return text;
}
